Subject: Re: git history and file moves

From: Jakub Narebski <[email-masked]>
Date: Fri, 24 Oct 2008 15:13:02 -0700 (PDT)

"Moore, Robert" <[email-masked]> writes:

> 
> Thanks,
> Bob
> 
> >-----Original Message-----
>Michael J Gruber wrote:
>>Alex Riesen venit, vidit, dixit 10/22/08 13:19:
>>> 2008/10/22 Lin Ming <[email-masked]>:

>>>> I'm looking for a way to move files to a new directory and have the
>>>> full history follow the file automatically. Is this possible?
>>>>
>>>> I know about --follow, but I want the history to just follow the file
>>>> transparently. ...
>>>
>>> Of all Git tools, what does not do this "transparently" or "automatically"?
[...]

>>>> Also, we have a git web interface and we want the full
>>>> history for the moved files to be available.
>>>
>>> It is available. Whether it is shown is another question. git-web can
>>> be improved (or just configured?)
>>
>> By default, gitweb uses "-M" for diff. You can specify all options (-C,
>> -CC, -B) using  "@diff_opts" in the config file for gitweb.cgi - if that
>> is what you are using. Is it?
>>
>> Anyways, using default configs for git log and gitweb.cgi both of them
>> show the full history (renames, history before and after) for me here,
>> using current git (1.6.0.3.514.g2f91b). What is your setup?
>
> Here's what we have:
> 
> /var/www/cgi-bin/gitweb.acpica/gitweb.conf
> 
> Containts this : GITWEB_CSS = "/icons/gitweb.css";

This fragment has nothing to do with rename (file movement) detection.

> 
> What should we add to automatically get all file history?

While the 'commitdiff' view would, in default gitweb configuration,
contain information about file renames, currently 'history' view does
not support '--follow' option to git-log.  It wouldn't be too hard to
add it, but it just wasn't done (well, add to this the fact that
--follow works only for simple cases).

-- 
Jakub Narebski
Poland
ShadeHawk on #git